//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

#ifndef __SINGLEHOSTCONFIGURATOR_H__
#define __SINGLEHOSTCONFIGURATOR_H__


#include <omnetpp.h>
#include <BasicModule.h>

#include <UnderlayConfigurator.h>
#include <InitStages.h>


class SingleHostConfigurator : public UnderlayConfigurator
{
protected:

    void initializeUnderlay(int stage);
    void finish();
    void setDisplayString();

    // Not used here:
    int createRandomNode(bool initialize) {error("createRandomNode can't be used with singleHostUnderlay!"); return 0;}
    void killRandomNode() {error("killRandomNode can't be used with singleHostUnderlay!");}
    void migrateRandomNode() {error("migrateRandomNode can't be used with singleHostUnderlay!");}
};


#endif
